Description

In our installation, with plenty of issues and projects, we met a performance issue with the assigned_to_role filter on issues.

The SQL query was very slow when using this filter.

So, here is a patch to make this request a lot faster:

diff --git a/app/models/issue_query.rb b/app/models/issue_query.rb

index eb7684cc2..ec3d5ec62 100644

--- a/app/models/issue_query.rb

+++ b/app/models/issue_query.rb

@@ -575,8 +575,9 @@ class IssueQuery < Query

         end

       sw = operator == "!" ? 'NOT' : ''

       nl = operator == "!" ? "#{Issue.table_name}.assigned_to_id IS NULL OR" : ''

-      "(#{nl} #{Issue.table_name}.assigned_to_id #{sw} IN (SELECT DISTINCT #{Member.table_name}.u

ser_id FROM #{Member.table_name}, #{MemberRole.table_name}" +

-        " WHERE #{Member.table_name}.project_id = #{Issue.table_name}.project_id AND #{Member.tab

le_name}.id = #{MemberRole.table_name}.member_id AND #{role_cond}))" 

+      "(#{nl} (#{Issue.table_name}.assigned_to_id, #{Issue.table_name}.project_id) #{sw} IN (" +

+        " SELECT DISTINCT #{Member.table_name}.user_id, #{Member.table_name}.project_id FROM #{Me

mber.table_name}, #{MemberRole.table_name}" +

+        " WHERE #{Member.table_name}.id = #{MemberRole.table_name}.member_id AND #{role_cond}))" 

     end

   end

 Thank you for considering this change.

Related issues:

Related to Redmine - Defect #39443: Invalid statement query error on MSSQL wh... Closed

Associated revisions

Revision 22333 - 2023-10-09 07:19 - Go MAEDA

Refactor SQL construction in IssueQuery#sql_for_assigned_to_role_field for better readability (#38319).

Revision 22334 - 2023-10-09 07:30 - Go MAEDA

Optimize IssueQuery#sql_for_assigned_to_role_field for PostgreSQL (#38319).

Contributed by Vincent Robert.

History

#1 - 2023-03-02 11:14 - Holger Just

- Status changed from New to Needs feedback

Thank you for your contribution. Unfortunately though, on a first check of your poatch, I was not able to find significant performance differences

between your patched query and the current one.

Could you please describe in more detail what this patch aims to achieve? Please state your database engine and version and show full

representative SQL queries of both versions (possibly with anonymized ids if required) along with the EXPLAIN output of both queries and the timing

differences you have observed.

#2 - 2023-03-02 11:29 - Vincent Robert

Hi Holger. Thanks for your feedback.
I'm using PostgreSQL 13.

Here is a simplified version of the current SQL Query generated by Redmine for the assigned_to_role filter :

SELECT "issues"."id" 

FROM "issues" 

WHERE issues.assigned_to_id IN (SELECT DISTINCT members.user_id

  FROM members, member_roles

  WHERE members.id = member_roles.member_id

  AND issues.project_id = members.project_id

  AND member_roles.role_id IN ('3'))

 In my environment, this query returns 25 000 rows, in more than 30 seconds.

Here is the patched query :

SELECT "issues"."id" 

FROM "issues" 

WHERE (issues.assigned_to_id, issues.project_id) IN (SELECT DISTINCT members.user_id, members.project_id

  FROM members, member_roles

  WHERE members.id = member_roles.member_id

  AND member_roles.role_id IN ('3'))

 With this new version, I get the same rows (25 000), but it only takes 200 ms.

It seems to me that the current version must execute the subquery for each issue.

The main difference is that with the new patched query, the subquery can be executed only once.

Do you agree?

#3 - 2023-03-03 03:28 - Go MAEDA

- Target version changed from 5.0.5 to 5.0.6

#4 - 2023-03-13 10:38 - Vincent Robert

- Status changed from Needs feedback to New

#5 - 2023-09-20 06:36 - Go MAEDA

- Target version changed from 5.0.6 to 5.1.0

#6 - 2023-10-09 07:32 - Go MAEDA

- Subject changed from Improve assigned_to_role filter performance to Optimize IssueQuery#sql_for_assigned_to_role_field for PostgreSQL

performance

- Assignee set to Go MAEDA

Committed the patch in r22334 after refactoring the existing code in r22333.

Thank you for your contribution.

#7 - 2023-10-09 07:34 - Go MAEDA

- Status changed from New to Closed

#8 - 2023-11-07 08:46 - Marius BĂLTEANU

- Related to Defect #39443: Invalid statement query error on MSSQL when role filter is used in issues query added

Files

issue_query.diff 1.01 KB 2023-03-02 Vincent Robert
